// plugin.cpp
#include "StdAfx.h"
#include "plugin.h"

STDMETHODIMP CPlugin::get_Path(BSTR *pVal)
{
	if(!pVal)
		return E_POINTER;
	CString strPath;
	strPath.ReleaseBuffer(GetModuleFileName(m_pInfo->hInst, strPath.GetBuffer(MAX_PATH), MAX_PATH));
	*pVal = strPath.AllocSysString();
	return S_OK;
}

STDMETHODIMP CPlugin::get_hInstance(long *pVal)
{
	if(!pVal)
		return E_POINTER;
	*pVal = reinterpret_cast<long>(m_pInfo->hInst);
	return S_OK;
}

STDMETHODIMP CPlugin::get_Object(IDispatch **pVal)
{
	if(!pVal)
		return E_POINTER;
	if(m_pInfo->pDisp)
	{
		*pVal = m_pInfo->pDisp;
		m_pInfo->pDisp->AddRef();
	}
	else
		*pVal = NULL;
	return S_OK;
}
