// userform.h
#pragma once
#include "../Resource.h"
//http://support.microsoft.com/kb/224305

// ClientItem  msform.    OnActivateUI
class CUserFormCntrItem : public COleDocObjectItem
{
public:
	~CUserFormCntrItem();
	CUserFormCntrItem(COleDocument* pContainer = NULL) : COleDocObjectItem(pContainer){}
	void OnActivateUI();
};

class CUserFormView : public CView
{
public:
	DECLARE_DYNCREATE(CUserFormView);
	
	CUserFormView() : m_pForm(NULL){}
	void Create(CDocument* pDoc, CWnd* pParent);

protected:

	void OnInitialUpdate();
	void ResizeForm();
	void OnSize(UINT nType, int cx, int cy);
	void OnDestroy();
	BOOL PreTranslateMessage(MSG* pMsg);

	void OnSetControlPicture();
	void OnUpdateSetControlPicture(CCmdUI* pCmdUI);

	void OnDraw(CDC*){}

	CUserFormCntrItem* m_pForm;
	DECLARE_MESSAGE_MAP();
};


class CUserFormDoc : public COleDocument
{
public:
	DECLARE_DYNCREATE(CUserFormDoc);
	
	CUserFormDoc();
	~CUserFormDoc();
	
	static void Init();
	static CUserFormDoc* DesignForm(LPCSTR lpFile = NULL);
	
	CUserFormCntrItem* GetUserFormItem()	{return m_pItem;}
	BOOL GetDesignMode() {return m_bDesignMode;}
	void SetDesignMode(BOOL bMode);
	
	BOOL OnOpenDocument(LPCTSTR lpszPathName);
protected:
	void Serialize(CArchive& ar);
	BOOL OnSaveDocument(LPCTSTR lpszPathName);
	BOOL OnNewDocument();
	void SetModifiedFlag(BOOL bModified);
	BOOL IsModified();
	
	ILockBytesPtr m_lb;
	BOOL m_bDesignMode;
	CUserFormCntrItem* m_pItem;
	static CMultiDocTemplate* m_pTemplate;
};

